/*---------------------------------------------------------------------------------
 bbEdgeFlip ( 2004 Slade Taylor [bladestaylor@yahoo.com])
 ----------------------------------------------------------------------------------
 bbEdgeFlip is a plugin for Blackbox for Windows.  For more information,
 please visit [http://bb4win.org] or [http://sourceforge.net/projects/bb4win].
 ----------------------------------------------------------------------------------
 bbEdgeFlip is free software, released under the GNU General Public License,
 version 2, as published by the Free Software Foundation.  It is distributed
 WITHOUT ANY WARRANTY--without even the implied warranty of MERCHANTABILITY
 or FITNESS FOR A PARTICULAR PURPOSE.  Please see the GNU General Public
 License for more details:  [http://www.fsf.org/licenses/gpl.html].
 --------------------------------------------------------------------------------*/

#include "WMHook.h"

//---------------------------------------------------------------------------------

bool WINAPI DllMain(HINSTANCE hinst, DWORD fdwReason, LPVOID lpvReserved)
{
    hFlipWnd = FindWindow("bbEdgeFlip", NULL);
    if (fdwReason == DLL_PROCESS_ATTACH)
        DisableThreadLibraryCalls(hInstance = hinst);
    return true;
}

//---------------------------------------------------------------------------------

void SetHook()
{
    if (!(hDesktopWnd = FindWindow("BBLeanDesktop", NULL))          &&
        !(hDesktopWnd = FindWindow("DesktopBackgroundClass", NULL)) &&
        !(hDesktopWnd = GetDesktopWindow()))
        return;

    BBThread = GetCurrentThreadId();
    hHook = SetWindowsHookEx(WH_CALLWNDPROC, HookProc, hInstance, 0);
    hMouseHook = SetWindowsHookEx(WH_MOUSE, MouseProc, hInstance, 0);
}

//---------------------------------------------------------------------------------

void UnsetHook()
{
    if (hHook)
        UnhookWindowsHookEx(hHook);
    if (hMouseHook)
        UnhookWindowsHookEx(hMouseHook);
}

//---------------------------------------------------------------------------------

LRESULT CALLBACK HookProc(int nCode, WPARAM wParam, LPARAM lParam)
{
    if ((nCode >= 0) && lParam && (((CWPSTRUCT*)lParam)->message == WM_MOVING))
        SendMessage(hFlipWnd, FLIP_WM_MOVING, (WPARAM)((CWPSTRUCT*)lParam)->hwnd, NULL);
    return CallNextHookEx(hHook, nCode, wParam, lParam);
}

//---------------------------------------------------------------------------------

LRESULT CALLBACK MouseProc(int nCode, WPARAM wParam, LPARAM lParam)
{
    if (nCode == HC_ACTION) switch (wParam)
    {
        case WM_MOUSEMOVE:
        case WM_NCMOUSEMOVE:
            {
                MOUSEHOOKSTRUCT *pData = (MOUSEHOOKSTRUCT*)lParam;
                if ((GetWindowThreadProcessId(pData->hwnd, NULL) != BBThread) || (pData->hwnd == hDesktopWnd))
                    PostMessage(hFlipWnd, FLIP_WM_MOUSEMOVE, pData->pt.y, pData->pt.x);
            }
    }
    return CallNextHookEx(hMouseHook, nCode, wParam, lParam);
}

//---------------------------------------------------------------------------------
