/*---------------------------------------------------------------------------------
 bbEdgeFlip ( 2004 Slade Taylor [bladestaylor@yahoo.com])
 ----------------------------------------------------------------------------------
 bbEdgeFlip is a plugin for Blackbox for Windows.  For more information,
 please visit [http://bb4win.org] or [http://sourceforge.net/projects/bb4win].
 ----------------------------------------------------------------------------------
 bbEdgeFlip is free software, released under the GNU General Public License,
 version 2, as published by the Free Software Foundation.  It is distributed
 WITHOUT ANY WARRANTY--without even the implied warranty of MERCHANTABILITY
 or FITNESS FOR A PARTICULAR PURPOSE.  Please see the GNU General Public
 License for more details:  [http://www.fsf.org/licenses/gpl.html].
 --------------------------------------------------------------------------------*/

#ifndef _WIN32_WINNT
    #define _WIN32_WINNT 0x0500
#endif

#define VC_EXTRALEAN

#include "../bbLean/BBApi.h"

//--------------------------------

#define DESK_LEFT           0
#define DESK_RIGHT          1

//--------------------------------

#define FLIP_TIMER          1
#define DCHECK_TIMER        2

//--------------------------------

#define FLIP_WM_MOVING      12000
#define FLIP_WM_MOUSEMOVE   12002

//--------------------------------

#define TRIGGER_DELAY       true
#define TRIGGER_SLIDE       false

//--------------------------------

#define ACTION_UNIX         true
#define ACTION_WINDOWS      false

//---------------------------------------------------------------------------------

enum PLUGIN_INFO { NAME_VERSION = 0, APPNAME, VERSION, AUTHOR, RELEASEDATE, WEBLINK, EMAIL };

extern "C"
{
    __declspec(dllexport) void      endPlugin(HINSTANCE);
    __declspec(dllexport) int       beginPlugin(HINSTANCE);

    __declspec(dllexport) LPCSTR    pluginInfo(int x)
    {
        switch (x)
        {
            case APPNAME:       return "bbEdgeFlip";
            case VERSION:       return "0.0.7";
            case AUTHOR:        return "bladestaylor";
            case RELEASEDATE:   return "May 15, 2004";
            case WEBLINK:       return "http://bb4win.sourceforge.net/bladestaylor/";
            case EMAIL:         return "bladestaylor@yahoo.com";
            default:            return "bbEdgeFlip 0.0.7";
        }
    };
}

//---------------------------------------------------------------------------------

static enum FLIP_CONTROL
{
    CONTROL_NULL = 0,
    CONTROL_RIGHT,
    CONTROL_LEFT
};

FLIP_CONTROL FlipControl = CONTROL_NULL;

//---------------------------------------------------------------------------------

static LRESULT CALLBACK     PluginProc(HWND, UINT, WPARAM, LPARAM);

static bool                 ProcessFlip(FLIP_CONTROL, WPARAM, bool, bool);

static void                 Reconfig(),
                            RCSettings(),
                            TransferWindow(WPARAM, HWND, int),
                            ProcessWindowMove(HWND, WPARAM, int),
                            RC_String(char*, char*, char*, int),
                            RC_Int(char*, int*, int);

//---------------------------------------------------------------------------------

static void         (*pSetHook)() = NULL,
                    (*pUnsetHook)() = NULL,
                    (*pGetDesktopInfo)(DesktopInfo*) = NULL;

static int          bb_messages[] = {BB_RECONFIGURE, 0};

static int          VScreenX,
                    EdgeWidth,
                    SlideThres,
                    RepeatDelay,
                    InitialDelay,
                    VScreenWidth,
                    VScreenHeight,
                    LeftEdgeThres,
                    RightEdgeThres,
                    SlideThresPercent;

static HWND         hCoreWnd,
                    hFlipWnd;

static bool         bControlMove = false,
                    bTriggerType,
                    bActionType;

static char         RCpath[MAX_LINE_LENGTH];

static POINT        MouseEventPoint,
                    InitialMousePoint;

static DesktopInfo  CurrentDesktopInfo;

static HMODULE      hWinMoveHook;

//---------------------------------------------------------------------------------
